/***************************************************************
*
*
*   ShareCom 1.0   
*    Copyright (C)  1994 Identity Software Inc
*
* semaphor.h
* 
* Portable Semaphores
*
*/






#ifndef SEMAPHOR_H

#define SEMAPHOR_H


struct semaphorestruct {
  int sem_entry_count;
  du_thread_t * sem_waiting;
/* TAMMI mty */
#ifdef DEFOS2
  ULONG sem ;
#endif
#ifdef WINNT
  HANDLE sem_hsem;
#endif
};

#ifdef OS2
#define semaphore_enter(sema)    DosSemRequest(& ((semaphore_t *)sema)->sem, SEM_INDEFINITE_WAIT)
#define semaphore_leave(sema)    DosSemClear( & ((semaphore_t *)sema)->sem ) 
#endif


extern int semaphore_wait_and_grab (semaphore_t* sem, du_thread_t* thread);
#ifndef OS2
extern int semaphore_enter (semaphore_t *sem);
extern void semaphore_leave (semaphore_t *sem);
#endif
extern semaphore_t * semaphore_allocate (int count);

#ifdef WINNT
#define semaphore_enter(s) \
  WaitForSingleObject (s->sem_hsem, INFINITE)

#define semaphore_leave(s) \
  ReleaseSemaphore (s->sem_hsem, 1, NULL)

#endif

#endif


